diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index 2d21db4690..87cb1c78ba 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -1643,7 +1643,7 @@ get_object_address_type(ObjectType objtype, TypeName *typename, bool missing_ok)
 
 	if (objtype == OBJECT_DOMAIN)
 	{
-		if (((Form_pg_type) GETSTRUCT(tup))->typtype != TYPTYPE_DOMAIN)
+		if ((GETSTRUCT(pg_type, tup))->typtype != TYPTYPE_DOMAIN)
 			ereport(ERROR,
 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 					 errmsg("\"%s\" is not a domain",
@@ -1762,7 +1762,7 @@ get_object_address_opf_member(ObjectType objtype,
 				}
 				else
 				{
-					address.objectId = ((Form_pg_amop) GETSTRUCT(tp))->oid;
+					address.objectId = (GETSTRUCT(pg_amop, tp))->oid;
 					ReleaseSysCache(tp);
 				}
 			}
@@ -1793,7 +1793,7 @@ get_object_address_opf_member(ObjectType objtype,
 				}
 				else
 				{
-					address.objectId = ((Form_pg_amproc) GETSTRUCT(tp))->oid;
+					address.objectId = (GETSTRUCT(pg_amproc, tp))->oid;
 					ReleaseSysCache(tp);
 				}
 			}
@@ -1840,7 +1840,7 @@ get_object_address_usermapping(List *object, bool missing_ok)
 								username, servername)));
 			return address;
 		}
-		userid = ((Form_pg_authid) GETSTRUCT(tp))->oid;
+		userid = (GETSTRUCT(pg_authid, tp))->oid;
 		ReleaseSysCache(tp);
 	}
 
@@ -1867,7 +1867,7 @@ get_object_address_usermapping(List *object, bool missing_ok)
 		return address;
 	}
 
-	address.objectId = ((Form_pg_user_mapping) GETSTRUCT(tp))->oid;
+	address.objectId = (GETSTRUCT(pg_user_mapping, tp))->oid;
 
 	ReleaseSysCache(tp);
 
@@ -2040,7 +2040,7 @@ get_object_address_defacl(List *object, bool missing_ok)
 						 CStringGetDatum(username));
 	if (!HeapTupleIsValid(tp))
 		goto not_found;
-	userid = ((Form_pg_authid) GETSTRUCT(tp))->oid;
+	userid = (GETSTRUCT(pg_authid, tp))->oid;
 	ReleaseSysCache(tp);
 
 	/*
@@ -2064,7 +2064,7 @@ get_object_address_defacl(List *object, bool missing_ok)
 	if (!HeapTupleIsValid(tp))
 		goto not_found;
 
-	address.objectId = ((Form_pg_default_acl) GETSTRUCT(tp))->oid;
+	address.objectId = (GETSTRUCT(pg_default_acl, tp))->oid;
 	ReleaseSysCache(tp);
 
 	return address;
@@ -2440,7 +2440,7 @@ check_object_ownership(Oid roleid, ObjectType objtype, ObjectAddress address,
 					elog(ERROR, "constraint with OID %u does not exist",
 						 address.objectId);
 
-				contypid = ((Form_pg_constraint) GETSTRUCT(tuple))->contypid;
+				contypid = (GETSTRUCT(pg_constraint, tuple))->contypid;
 
 				ReleaseSysCache(tuple);
 
@@ -2908,7 +2908,7 @@ getPublicationSchemaInfo(const ObjectAddress *object, bool missing_ok,
 		return false;
 	}
 
-	pnform = (Form_pg_publication_namespace) GETSTRUCT(tup);
+	pnform = GETSTRUCT(pg_publication_namespace, tup);
 	*pubname = get_publication_name(pnform->pnpubid, missing_ok);
 	if (!(*pubname))
 	{
@@ -3028,7 +3028,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				castForm = (Form_pg_cast) GETSTRUCT(tup);
+				castForm = GETSTRUCT(pg_cast, tup);
 
 				appendStringInfo(&buffer, _("cast from %s to %s"),
 								 format_type_be(castForm->castsource),
@@ -3055,7 +3055,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				coll = (Form_pg_collation) GETSTRUCT(collTup);
+				coll = GETSTRUCT(pg_collation, collTup);
 
 				/* Qualify the name if not visible in search path */
 				if (CollationIsVisible(object->objectId))
@@ -3085,7 +3085,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				con = (Form_pg_constraint) GETSTRUCT(conTup);
+				con = GETSTRUCT(pg_constraint, conTup);
 
 				if (OidIsValid(con->conrelid))
 				{
@@ -3124,7 +3124,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				conv = (Form_pg_conversion) GETSTRUCT(conTup);
+				conv = GETSTRUCT(pg_conversion, conTup);
 
 				/* Qualify the name if not visible in search path */
 				if (ConversionIsVisible(object->objectId))
@@ -3208,14 +3208,14 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				opcForm = (Form_pg_opclass) GETSTRUCT(opcTup);
+				opcForm = GETSTRUCT(pg_opclass, opcTup);
 
 				amTup = SearchSysCache1(AMOID,
 										ObjectIdGetDatum(opcForm->opcmethod));
 				if (!HeapTupleIsValid(amTup))
 					elog(ERROR, "cache lookup failed for access method %u",
 						 opcForm->opcmethod);
-				amForm = (Form_pg_am) GETSTRUCT(amTup);
+				amForm = GETSTRUCT(pg_am, amTup);
 
 				/* Qualify the name if not visible in search path */
 				if (OpclassIsVisible(object->objectId))
@@ -3252,7 +3252,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 				}
 
 				appendStringInfo(&buffer, _("access method %s"),
-								 NameStr(((Form_pg_am) GETSTRUCT(tup))->amname));
+								 NameStr((GETSTRUCT(pg_am, tup))->amname));
 				ReleaseSysCache(tup);
 				break;
 			}
@@ -3290,7 +3290,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				amopForm = (Form_pg_amop) GETSTRUCT(tup);
+				amopForm = GETSTRUCT(pg_amop, tup);
 
 				initStringInfo(&opfam);
 				getOpFamilyDescription(&opfam, amopForm->amopfamily, false);
@@ -3347,7 +3347,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				amprocForm = (Form_pg_amproc) GETSTRUCT(tup);
+				amprocForm = GETSTRUCT(pg_amproc, tup);
 
 				initStringInfo(&opfam);
 				getOpFamilyDescription(&opfam, amprocForm->amprocfamily, false);
@@ -3403,7 +3403,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				rule = (Form_pg_rewrite) GETSTRUCT(tup);
+				rule = GETSTRUCT(pg_rewrite, tup);
 
 				initStringInfo(&rel);
 				getRelationDescription(&rel, rule->ev_class, false);
@@ -3449,7 +3449,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				trig = (Form_pg_trigger) GETSTRUCT(tup);
+				trig = GETSTRUCT(pg_trigger, tup);
 
 				initStringInfo(&rel);
 				getRelationDescription(&rel, trig->tgrelid, false);
@@ -3495,7 +3495,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				stxForm = (Form_pg_statistic_ext) GETSTRUCT(stxTup);
+				stxForm = GETSTRUCT(pg_statistic_ext, stxTup);
 
 				/* Qualify the name if not visible in search path */
 				if (StatisticsObjIsVisible(object->objectId))
@@ -3526,7 +3526,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 							 object->objectId);
 					break;
 				}
-				prsForm = (Form_pg_ts_parser) GETSTRUCT(tup);
+				prsForm = GETSTRUCT(pg_ts_parser, tup);
 
 				/* Qualify the name if not visible in search path */
 				if (TSParserIsVisible(object->objectId))
@@ -3557,7 +3557,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				dictForm = (Form_pg_ts_dict) GETSTRUCT(tup);
+				dictForm = GETSTRUCT(pg_ts_dict, tup);
 
 				/* Qualify the name if not visible in search path */
 				if (TSDictionaryIsVisible(object->objectId))
@@ -3588,7 +3588,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				tmplForm = (Form_pg_ts_template) GETSTRUCT(tup);
+				tmplForm = GETSTRUCT(pg_ts_template, tup);
 
 				/* Qualify the name if not visible in search path */
 				if (TSTemplateIsVisible(object->objectId))
@@ -3619,7 +3619,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				cfgForm = (Form_pg_ts_config) GETSTRUCT(tup);
+				cfgForm = GETSTRUCT(pg_ts_config, tup);
 
 				/* Qualify the name if not visible in search path */
 				if (TSConfigIsVisible(object->objectId))
@@ -3715,7 +3715,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				umform = (Form_pg_user_mapping) GETSTRUCT(tup);
+				umform = GETSTRUCT(pg_user_mapping, tup);
 				useid = umform->umuser;
 				srv = GetForeignServer(umform->umserver);
 
@@ -3764,7 +3764,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				defacl = (Form_pg_default_acl) GETSTRUCT(tup);
+				defacl = GETSTRUCT(pg_default_acl, tup);
 
 				rolename = GetUserNameFromId(defacl->defaclrole, false);
 
@@ -3869,7 +3869,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 				appendStringInfo(&buffer, _("event trigger %s"),
-								 NameStr(((Form_pg_event_trigger) GETSTRUCT(tup))->evtname));
+								 NameStr((GETSTRUCT(pg_event_trigger, tup))->evtname));
 				ReleaseSysCache(tup);
 				break;
 			}
@@ -3932,7 +3932,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				form_policy = (Form_pg_policy) GETSTRUCT(tuple);
+				form_policy = GETSTRUCT(pg_policy, tuple);
 
 				initStringInfo(&rel);
 				getRelationDescription(&rel, form_policy->polrelid, false);
@@ -3989,7 +3989,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				prform = (Form_pg_publication_rel) GETSTRUCT(tup);
+				prform = GETSTRUCT(pg_publication_rel, tup);
 				pubname = get_publication_name(prform->prpubid, false);
 
 				initStringInfo(&rel);
@@ -4028,7 +4028,7 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 					break;
 				}
 
-				trfForm = (Form_pg_transform) GETSTRUCT(trfTup);
+				trfForm = GETSTRUCT(pg_transform, trfTup);
 
 				appendStringInfo(&buffer, _("transform for %s language %s"),
 								 format_type_be(trfForm->trftype),
@@ -4087,7 +4087,7 @@ getRelationDescription(StringInfo buffer, Oid relid, bool missing_ok)
 			elog(ERROR, "cache lookup failed for relation %u", relid);
 		return;
 	}
-	relForm = (Form_pg_class) GETSTRUCT(relTup);
+	relForm = GETSTRUCT(pg_class, relTup);
 
 	/* Qualify the name if not visible in search path */
 	if (RelationIsVisible(relid))
@@ -4162,13 +4162,13 @@ getOpFamilyDescription(StringInfo buffer, Oid opfid, bool missing_ok)
 			elog(ERROR, "cache lookup failed for opfamily %u", opfid);
 		return;
 	}
-	opfForm = (Form_pg_opfamily) GETSTRUCT(opfTup);
+	opfForm = GETSTRUCT(pg_opfamily, opfTup);
 
 	amTup = SearchSysCache1(AMOID, ObjectIdGetDatum(opfForm->opfmethod));
 	if (!HeapTupleIsValid(amTup))
 		elog(ERROR, "cache lookup failed for access method %u",
 			 opfForm->opfmethod);
-	amForm = (Form_pg_am) GETSTRUCT(amTup);
+	amForm = GETSTRUCT(pg_am, amTup);
 
 	/* Qualify the name if not visible in search path */
 	if (OpfamilyIsVisible(opfid))
@@ -4626,7 +4626,7 @@ getRelationTypeDescription(StringInfo buffer, Oid relid, int32 objectSubId,
 		appendStringInfoString(buffer, "relation");
 		return;
 	}
-	relForm = (Form_pg_class) GETSTRUCT(relTup);
+	relForm = GETSTRUCT(pg_class, relTup);
 
 	switch (relForm->relkind)
 	{
@@ -4693,7 +4693,7 @@ getConstraintTypeDescription(StringInfo buffer, Oid constroid, bool missing_ok)
 		return;
 	}
 
-	constrForm = (Form_pg_constraint) GETSTRUCT(constrTup);
+	constrForm = GETSTRUCT(pg_constraint, constrTup);
 
 	if (OidIsValid(constrForm->conrelid))
 		appendStringInfoString(buffer, "table constraint");
@@ -4726,7 +4726,7 @@ getProcedureTypeDescription(StringInfo buffer, Oid procid,
 		appendStringInfoString(buffer, "routine");
 		return;
 	}
-	procForm = (Form_pg_proc) GETSTRUCT(procTup);
+	procForm = GETSTRUCT(pg_proc, procTup);
 
 	if (procForm->prokind == PROKIND_AGGREGATE)
 		appendStringInfoString(buffer, "aggregate");
@@ -4870,7 +4870,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				castForm = (Form_pg_cast) GETSTRUCT(tup);
+				castForm = GETSTRUCT(pg_cast, tup);
 
 				appendStringInfo(&buffer, "(%s AS %s)",
 								 format_type_be_qualified(castForm->castsource),
@@ -4901,7 +4901,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				coll = (Form_pg_collation) GETSTRUCT(collTup);
+				coll = GETSTRUCT(pg_collation, collTup);
 				schema = get_namespace_name_or_temp(coll->collnamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -4927,7 +4927,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				con = (Form_pg_constraint) GETSTRUCT(conTup);
+				con = GETSTRUCT(pg_constraint, conTup);
 
 				if (OidIsValid(con->conrelid))
 				{
@@ -4975,7 +4975,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				conForm = (Form_pg_conversion) GETSTRUCT(conTup);
+				conForm = GETSTRUCT(pg_conversion, conTup);
 				schema = get_namespace_name_or_temp(conForm->connamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -5022,7 +5022,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				langForm = (Form_pg_language) GETSTRUCT(langTup);
+				langForm = GETSTRUCT(pg_language, langTup);
 				appendStringInfoString(&buffer,
 									   quote_identifier(NameStr(langForm->lanname)));
 				if (objname)
@@ -5071,7 +5071,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				opcForm = (Form_pg_opclass) GETSTRUCT(opcTup);
+				opcForm = GETSTRUCT(pg_opclass, opcTup);
 				schema = get_namespace_name_or_temp(opcForm->opcnamespace);
 
 				amTup = SearchSysCache1(AMOID,
@@ -5079,7 +5079,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				if (!HeapTupleIsValid(amTup))
 					elog(ERROR, "cache lookup failed for access method %u",
 						 opcForm->opcmethod);
-				amForm = (Form_pg_am) GETSTRUCT(amTup);
+				amForm = GETSTRUCT(pg_am, amTup);
 
 				appendStringInfo(&buffer, "%s USING %s",
 								 quote_qualified_identifier(schema,
@@ -5153,7 +5153,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				amopForm = (Form_pg_amop) GETSTRUCT(tup);
+				amopForm = GETSTRUCT(pg_amop, tup);
 
 				initStringInfo(&opfam);
 				getOpFamilyIdentity(&opfam, amopForm->amopfamily, objname,
@@ -5215,7 +5215,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				amprocForm = (Form_pg_amproc) GETSTRUCT(tup);
+				amprocForm = GETSTRUCT(pg_amproc, tup);
 
 				initStringInfo(&opfam);
 				getOpFamilyIdentity(&opfam, amprocForm->amprocfamily, objname,
@@ -5263,7 +5263,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				rule = (Form_pg_rewrite) GETSTRUCT(tup);
+				rule = GETSTRUCT(pg_rewrite, tup);
 
 				appendStringInfo(&buffer, "%s on ",
 								 quote_identifier(NameStr(rule->rulename)));
@@ -5296,7 +5296,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				trig = (Form_pg_trigger) GETSTRUCT(tup);
+				trig = GETSTRUCT(pg_trigger, tup);
 
 				appendStringInfo(&buffer, "%s on ",
 								 quote_identifier(NameStr(trig->tgname)));
@@ -5342,7 +5342,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				formStatistic = (Form_pg_statistic_ext) GETSTRUCT(tup);
+				formStatistic = GETSTRUCT(pg_statistic_ext, tup);
 				schema = get_namespace_name_or_temp(formStatistic->stxnamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -5369,7 +5369,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				formParser = (Form_pg_ts_parser) GETSTRUCT(tup);
+				formParser = GETSTRUCT(pg_ts_parser, tup);
 				schema = get_namespace_name_or_temp(formParser->prsnamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -5396,7 +5396,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				formDict = (Form_pg_ts_dict) GETSTRUCT(tup);
+				formDict = GETSTRUCT(pg_ts_dict, tup);
 				schema = get_namespace_name_or_temp(formDict->dictnamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -5423,7 +5423,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				formTmpl = (Form_pg_ts_template) GETSTRUCT(tup);
+				formTmpl = GETSTRUCT(pg_ts_template, tup);
 				schema = get_namespace_name_or_temp(formTmpl->tmplnamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -5450,7 +5450,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				formCfg = (Form_pg_ts_config) GETSTRUCT(tup);
+				formCfg = GETSTRUCT(pg_ts_config, tup);
 				schema = get_namespace_name_or_temp(formCfg->cfgnamespace);
 				appendStringInfoString(&buffer,
 									   quote_qualified_identifier(schema,
@@ -5562,7 +5562,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				umform = (Form_pg_user_mapping) GETSTRUCT(tup);
+				umform = GETSTRUCT(pg_user_mapping, tup);
 				useid = umform->umuser;
 				srv = GetForeignServer(umform->umserver);
 
@@ -5618,7 +5618,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				defacl = (Form_pg_default_acl) GETSTRUCT(tup);
+				defacl = GETSTRUCT(pg_default_acl, tup);
 
 				username = GetUserNameFromId(defacl->defaclrole, false);
 				appendStringInfo(&buffer,
@@ -5705,7 +5705,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 							 object->objectId);
 					break;
 				}
-				trigForm = (Form_pg_event_trigger) GETSTRUCT(tup);
+				trigForm = GETSTRUCT(pg_event_trigger, tup);
 				evtname = pstrdup(NameStr(trigForm->evtname));
 				appendStringInfoString(&buffer, quote_identifier(evtname));
 				if (objname)
@@ -5763,7 +5763,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				policy = (Form_pg_policy) GETSTRUCT(tup);
+				policy = GETSTRUCT(pg_policy, tup);
 
 				appendStringInfo(&buffer, "%s on ",
 								 quote_identifier(NameStr(policy->polname)));
@@ -5830,7 +5830,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				prform = (Form_pg_publication_rel) GETSTRUCT(tup);
+				prform = GETSTRUCT(pg_publication_rel, tup);
 				pubname = get_publication_name(prform->prpubid, false);
 
 				getRelationIdentity(&buffer, prform->prrelid, objname, false);
@@ -5882,7 +5882,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					break;
 				}
 
-				transform = (Form_pg_transform) GETSTRUCT(tup);
+				transform = GETSTRUCT(pg_transform, tup);
 
 				transformType = format_type_be_qualified(transform->trftype);
 				transformLang = get_language_name(transform->trflang, false);
@@ -5948,13 +5948,13 @@ getOpFamilyIdentity(StringInfo buffer, Oid opfid, List **object,
 			elog(ERROR, "cache lookup failed for opfamily %u", opfid);
 		return;
 	}
-	opfForm = (Form_pg_opfamily) GETSTRUCT(opfTup);
+	opfForm = GETSTRUCT(pg_opfamily, opfTup);
 
 	amTup = SearchSysCache1(AMOID, ObjectIdGetDatum(opfForm->opfmethod));
 	if (!HeapTupleIsValid(amTup))
 		elog(ERROR, "cache lookup failed for access method %u",
 			 opfForm->opfmethod);
-	amForm = (Form_pg_am) GETSTRUCT(amTup);
+	amForm = GETSTRUCT(pg_am, amTup);
 
 	schema = get_namespace_name_or_temp(opfForm->opfnamespace);
 	appendStringInfo(buffer, "%s USING %s",
@@ -5994,7 +5994,7 @@ getRelationIdentity(StringInfo buffer, Oid relid, List **object,
 			*object = NIL;
 		return;
 	}
-	relForm = (Form_pg_class) GETSTRUCT(relTup);
+	relForm = GETSTRUCT(pg_class, relTup);
 
 	schema = get_namespace_name_or_temp(relForm->relnamespace);
 	appendStringInfoString(buffer,
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index c6ec479004..a3d4ebe38d 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -106,7 +106,7 @@ get_partition_parent_worker(Relation inhRel, Oid relid, bool *detach_pending)
 	tuple = systable_getnext(scan);
 	if (HeapTupleIsValid(tuple))
 	{
-		Form_pg_inherits form = (Form_pg_inherits) GETSTRUCT(tuple);
+		Form_pg_inherits form = GETSTRUCT(pg_inherits, tuple);
 
 		/* Let caller know of partition being detached */
 		if (form->inhdetachpending)
@@ -187,7 +187,7 @@ index_get_partition(Relation partition, Oid indexId)
 		tup = SearchSysCache1(RELOID, ObjectIdGetDatum(partIdx));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for relation %u", partIdx);
-		classForm = (Form_pg_class) GETSTRUCT(tup);
+		classForm = GETSTRUCT(pg_class, tup);
 		ispartition = classForm->relispartition;
 		ReleaseSysCache(tup);
 		if (!ispartition)
@@ -321,7 +321,7 @@ get_default_partition_oid(Oid parentId)
 	{
 		Form_pg_partitioned_table part_table_form;
 
-		part_table_form = (Form_pg_partitioned_table) GETSTRUCT(tuple);
+		part_table_form = GETSTRUCT(pg_partitioned_table, tuple);
 		defaultPartId = part_table_form->partdefid;
 		ReleaseSysCache(tuple);
 	}
@@ -349,7 +349,7 @@ update_default_partition_oid(Oid parentId, Oid defaultPartId)
 		elog(ERROR, "cache lookup failed for partition key of relation %u",
 			 parentId);
 
-	part_table_form = (Form_pg_partitioned_table) GETSTRUCT(tuple);
+	part_table_form = GETSTRUCT(pg_partitioned_table, tuple);
 	part_table_form->partdefid = defaultPartId;
 	CatalogTupleUpdate(pg_partitioned_table, &tuple->t_self, tuple);
 
diff --git a/src/backend/catalog/pg_aggregate.c b/src/backend/catalog/pg_aggregate.c
index 0d0daa69b3..392296edbe 100644
--- a/src/backend/catalog/pg_aggregate.c
+++ b/src/backend/catalog/pg_aggregate.c
@@ -250,7 +250,7 @@ AggregateCreate(const char *aggName,
 	tup = SearchSysCache1(PROCOID, ObjectIdGetDatum(transfn));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for function %u", transfn);
-	proc = (Form_pg_proc) GETSTRUCT(tup);
+	proc = GETSTRUCT(pg_proc, tup);
 
 	/*
 	 * If the transfn is strict and the initval is NULL, make sure first input
@@ -294,7 +294,7 @@ AggregateCreate(const char *aggName,
 		tup = SearchSysCache1(PROCOID, ObjectIdGetDatum(mtransfn));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for function %u", mtransfn);
-		proc = (Form_pg_proc) GETSTRUCT(tup);
+		proc = GETSTRUCT(pg_proc, tup);
 
 		/*
 		 * If the mtransfn is strict and the minitval is NULL, check first
@@ -339,7 +339,7 @@ AggregateCreate(const char *aggName,
 		tup = SearchSysCache1(PROCOID, ObjectIdGetDatum(minvtransfn));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for function %u", minvtransfn);
-		proc = (Form_pg_proc) GETSTRUCT(tup);
+		proc = GETSTRUCT(pg_proc, tup);
 
 		/*
 		 * We require the strictness settings of the forward and inverse
@@ -692,7 +692,7 @@ AggregateCreate(const char *aggName,
 
 	if (HeapTupleIsValid(oldtup))
 	{
-		Form_pg_aggregate oldagg = (Form_pg_aggregate) GETSTRUCT(oldtup);
+		Form_pg_aggregate oldagg = GETSTRUCT(pg_aggregate, oldtup);
 
 		/*
 		 * If we're replacing an existing entry, we need to validate that
diff --git a/src/backend/catalog/pg_attrdef.c b/src/backend/catalog/pg_attrdef.c
index c5d4a9912e..d52e1050ed 100644
--- a/src/backend/catalog/pg_attrdef.c
+++ b/src/backend/catalog/pg_attrdef.c
@@ -101,7 +101,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	if (!HeapTupleIsValid(atttup))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, RelationGetRelid(rel));
-	attStruct = (Form_pg_attribute) GETSTRUCT(atttup);
+	attStruct = GETSTRUCT(pg_attribute, atttup);
 	attgenerated = attStruct->attgenerated;
 	if (!attStruct->atthasdef)
 	{
@@ -240,7 +240,7 @@ RemoveAttrDefault(Oid relid, AttrNumber attnum,
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
 		ObjectAddress object;
-		Form_pg_attrdef attrtuple = (Form_pg_attrdef) GETSTRUCT(tuple);
+		Form_pg_attrdef attrtuple = GETSTRUCT(pg_attrdef, tuple);
 
 		object.classId = AttrDefaultRelationId;
 		object.objectId = attrtuple->oid;
@@ -295,8 +295,8 @@ RemoveAttrDefaultById(Oid attrdefId)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for attrdef %u", attrdefId);
 
-	myrelid = ((Form_pg_attrdef) GETSTRUCT(tuple))->adrelid;
-	myattnum = ((Form_pg_attrdef) GETSTRUCT(tuple))->adnum;
+	myrelid = (GETSTRUCT(pg_attrdef, tuple))->adrelid;
+	myattnum = (GETSTRUCT(pg_attrdef, tuple))->adnum;
 
 	/* Get an exclusive lock on the relation owning the attribute */
 	myrel = relation_open(myrelid, AccessExclusiveLock);
@@ -317,7 +317,7 @@ RemoveAttrDefaultById(Oid attrdefId)
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 myattnum, myrelid);
 
-	((Form_pg_attribute) GETSTRUCT(tuple))->atthasdef = false;
+	(GETSTRUCT(pg_attribute, tuple))->atthasdef = false;
 
 	CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple);
 
@@ -363,7 +363,7 @@ GetAttrDefaultOid(Oid relid, AttrNumber attnum)
 
 	if (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_attrdef atdform = (Form_pg_attrdef) GETSTRUCT(tup);
+		Form_pg_attrdef atdform = GETSTRUCT(pg_attrdef, tup);
 
 		result = atdform->oid;
 	}
@@ -399,7 +399,7 @@ GetAttrDefaultColumnAddress(Oid attrdefoid)
 
 	if (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_attrdef atdform = (Form_pg_attrdef) GETSTRUCT(tup);
+		Form_pg_attrdef atdform = GETSTRUCT(pg_attrdef, tup);
 
 		result.classId = RelationRelationId;
 		result.objectId = atdform->adrelid;
diff --git a/src/backend/catalog/pg_constraint.c b/src/backend/catalog/pg_constraint.c
index bb65fb1e0a..48f1653242 100644
--- a/src/backend/catalog/pg_constraint.c
+++ b/src/backend/catalog/pg_constraint.c
@@ -577,7 +577,7 @@ RemoveConstraintById(Oid conId)
 	tup = SearchSysCache1(CONSTROID, ObjectIdGetDatum(conId));
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for constraint %u", conId);
-	con = (Form_pg_constraint) GETSTRUCT(tup);
+	con = GETSTRUCT(pg_constraint, tup);
 
 	/*
 	 * Special processing depending on what the constraint is for.
@@ -609,7 +609,7 @@ RemoveConstraintById(Oid conId)
 			if (!HeapTupleIsValid(relTup))
 				elog(ERROR, "cache lookup failed for relation %u",
 					 con->conrelid);
-			classForm = (Form_pg_class) GETSTRUCT(relTup);
+			classForm = GETSTRUCT(pg_class, relTup);
 
 			if (classForm->relchecks == 0)	/* should not happen */
 				elog(ERROR, "relation \"%s\" has relchecks = 0",
@@ -668,7 +668,7 @@ RenameConstraintById(Oid conId, const char *newname)
 	tuple = SearchSysCacheCopy1(CONSTROID, ObjectIdGetDatum(conId));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for constraint %u", conId);
-	con = (Form_pg_constraint) GETSTRUCT(tuple);
+	con = GETSTRUCT(pg_constraint, tuple);
 
 	/*
 	 * For user-friendliness, check whether the name is already in use.
@@ -733,7 +733,7 @@ AlterConstraintNamespaces(Oid ownerId, Oid oldNspId,
 
 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
 	{
-		Form_pg_constraint conform = (Form_pg_constraint) GETSTRUCT(tup);
+		Form_pg_constraint conform = GETSTRUCT(pg_constraint, tup);
 		ObjectAddress thisobj;
 
 		ObjectAddressSet(thisobj, ConstraintRelationId, conform->oid);
@@ -745,7 +745,7 @@ AlterConstraintNamespaces(Oid ownerId, Oid oldNspId,
 		if (conform->connamespace == oldNspId && oldNspId != newNspId)
 		{
 			tup = heap_copytuple(tup);
-			conform = (Form_pg_constraint) GETSTRUCT(tup);
+			conform = GETSTRUCT(pg_constraint, tup);
 
 			conform->connamespace = newNspId;
 
@@ -794,7 +794,7 @@ ConstraintSetParentConstraint(Oid childConstrId,
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for constraint %u", childConstrId);
 	newtup = heap_copytuple(tuple);
-	constrForm = (Form_pg_constraint) GETSTRUCT(newtup);
+	constrForm = GETSTRUCT(pg_constraint, newtup);
 	if (OidIsValid(parentConstrId))
 	{
 		/* don't allow setting parent for a constraint that already has one */
@@ -875,7 +875,7 @@ get_relation_constraint_oid(Oid relid, const char *conname, bool missing_ok)
 
 	/* There can be at most one matching row */
 	if (HeapTupleIsValid(tuple = systable_getnext(scan)))
-		conOid = ((Form_pg_constraint) GETSTRUCT(tuple))->oid;
+		conOid = (GETSTRUCT(pg_constraint, tuple))->oid;
 
 	systable_endscan(scan);
 
@@ -940,7 +940,7 @@ get_relation_constraint_attnos(Oid relid, const char *conname,
 		Datum		adatum;
 		bool		isNull;
 
-		*constraintOid = ((Form_pg_constraint) GETSTRUCT(tuple))->oid;
+		*constraintOid = (GETSTRUCT(pg_constraint, tuple))->oid;
 
 		/* Extract the conkey array, ie, attnums of constrained columns */
 		adatum = heap_getattr(tuple, Anum_pg_constraint_conkey,
@@ -1010,7 +1010,7 @@ get_relation_idx_constraint_oid(Oid relationId, Oid indexId)
 	{
 		Form_pg_constraint constrForm;
 
-		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		constrForm = GETSTRUCT(pg_constraint, tuple);
 		if (constrForm->conindid == indexId)
 		{
 			constraintId = constrForm->oid;
@@ -1057,7 +1057,7 @@ get_domain_constraint_oid(Oid typid, const char *conname, bool missing_ok)
 
 	/* There can be at most one matching row */
 	if (HeapTupleIsValid(tuple = systable_getnext(scan)))
-		conOid = ((Form_pg_constraint) GETSTRUCT(tuple))->oid;
+		conOid = (GETSTRUCT(pg_constraint, tuple))->oid;
 
 	systable_endscan(scan);
 
@@ -1112,7 +1112,7 @@ get_primary_key_attnos(Oid relid, bool deferrableOk, Oid *constraintOid)
 
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tuple);
+		Form_pg_constraint con = GETSTRUCT(pg_constraint, tuple);
 		Datum		adatum;
 		bool		isNull;
 		ArrayType  *arr;
@@ -1137,7 +1137,7 @@ get_primary_key_attnos(Oid relid, bool deferrableOk, Oid *constraintOid)
 							  RelationGetDescr(pg_constraint), &isNull);
 		if (isNull)
 			elog(ERROR, "null conkey for constraint %u",
-				 ((Form_pg_constraint) GETSTRUCT(tuple))->oid);
+				 (GETSTRUCT(pg_constraint, tuple))->oid);
 		arr = DatumGetArrayTypeP(adatum);	/* ensure not toasted */
 		numkeys = ARR_DIMS(arr)[0];
 		if (ARR_NDIM(arr) != 1 ||
@@ -1153,7 +1153,7 @@ get_primary_key_attnos(Oid relid, bool deferrableOk, Oid *constraintOid)
 			pkattnos = bms_add_member(pkattnos,
 									  attnums[i] - FirstLowInvalidHeapAttributeNumber);
 		}
-		*constraintOid = ((Form_pg_constraint) GETSTRUCT(tuple))->oid;
+		*constraintOid = (GETSTRUCT(pg_constraint, tuple))->oid;
 
 		/* No need to search further */
 		break;
@@ -1185,7 +1185,7 @@ DeconstructFkConstraintRow(HeapTuple tuple, int *numfks,
 	ArrayType  *arr;
 	int			numkeys;
 
-	constrId = ((Form_pg_constraint) GETSTRUCT(tuple))->oid;
+	constrId = (GETSTRUCT(pg_constraint, tuple))->oid;
 
 	/*
 	 * We expect the arrays to be 1-D arrays of the right types; verify that.
diff --git a/src/backend/catalog/pg_conversion.c b/src/backend/catalog/pg_conversion.c
index 3d8b86ace7..4a39593d4a 100644
--- a/src/backend/catalog/pg_conversion.c
+++ b/src/backend/catalog/pg_conversion.c
@@ -168,7 +168,7 @@ FindDefaultConversion(Oid name_space, int32 for_encoding, int32 to_encoding)
 	for (i = 0; i < catlist->n_members; i++)
 	{
 		tuple = &catlist->members[i]->tuple;
-		body = (Form_pg_conversion) GETSTRUCT(tuple);
+		body = GETSTRUCT(pg_conversion, tuple);
 		if (body->condefault)
 		{
 			proc = body->conproc;
